﻿Imports DxLibDLL.DX

Module MainModule
    ''メイン関数
    Public Sub Main()
        Form1.Hide()

        DxInit()
        Func = FUNC_INIT

        Do
            ''画面をクリア
            ClearDrawScreen()

            ''処理本体
            Select Case Func
                Case FUNC_INIT
                    ImageLoad()
                    GameInit()
                    Func = FUNC_TITLE
                Case FUNC_TITLE
                    Title()
                    Func = FUNC_PLAYINIT
                Case FUNC_PLAYINIT
                    PlayInit()
                    Func = FUNC_MAIN
                Case FUNC_MAIN
                    GameMain()
                Case FUNC_CLEAR
                    Clear()
                    Func = FUNC_TITLE
                Case FUNC_GAMEOVER
                    GameOver()
                    Func = FUNC_TITLE
                Case FUNC_QUIT
                    Exit Do
            End Select

            ''フリップ
            ScreenFlip()

            ''メッセージ処理に異常があるか、ESCAPEが押されたら終了するために抜ける
            If CheckQuit() = DTRUE Then
                Exit Do
            End If
        Loop

        ''DXライブラリ終了
        DxLib_End()

        ''プログラム終了
        End
    End Sub

    Sub DxInit()
        ''ウィンドウモード設定
        ChangeWindowMode(WindowMode)

        ''DXライブラリ初期化
        DxLib_Init()

        ''ウィンドウタイトル設定
        SetWindowText(sTitle)

        ''ダブルバッファリング
        SetDrawScreen(DX_SCREEN_BACK)
    End Sub

    Sub ImageLoad()
        ''画像の取得処理はここに書いてください

    End Sub

    Sub GameInit()
        ''ゲームの初期化処理はこちらにどうぞ

    End Sub

    Sub Title()
        ''タイトルの表示処理はこちらに

    End Sub

    Sub PlayInit()
        ''プレイ開始時の処理はこちらに

    End Sub

    Sub GameMain()
        ''ゲームのメイン処理はこちらに

    End Sub

    Sub Clear()
        ''ゲームクリア、またはステージクリア時の処理はこちらに

    End Sub

    Sub GameOver()
        ''ゲームオーバー処理はこちらに書いてね

    End Sub

    Function CheckQuit() As Integer
        If ProcessMessage() = -1 Or CheckHitKey(KEY_INPUT_ESCAPE) = 1 Then
            Return DTRUE
        Else
            Return DFALSE
        End If
    End Function
End Module
